/*
File: DemonProtocol.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.protocols;

import webwisdom.tango.threads.DemonThreadIn;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.messages.*;
import java.io.*;
import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.CentralServer;

public class DemonProtocol  {

  protected ThreadOut out;
  protected CentralServer cs;
  private int UID;

  public DemonProtocol(ThreadOut outpar, CentralServer cspar) {
   
    out = outpar;
    UID = 0;
    cs = cspar;
  }
  
  public void handleCOMMAND(Message a){

   //  CommandMessage m = (CommandMessage) a;
//     int type = m.getAT();
//     String params = m.getPARAM();
//     int AID = m.getAID();
//     int SID = m.getSID();
   

    //   System.out.println("DEMON: COMMAND message received");
    // System.out.println("DEMON: Running application type " + type + " AID " + AID + " SID " + SID + " params " + params);

  
    cs.sendCSToCAB(a);
    
  }

  public void handleEVENT(Message a) {

    EventMessage m = (EventMessage) a;
  //   byte data[] = m.getData();
    int AID = m.getAID();
//    int i;
//      int len = m.getLen();

//      System.out.println("DEMON: EVENT message received");
//     System.out.println("DEMON: app " + AID + " data ");
//      for(i = 0; i < len; i ++) {

//        System.out.print(data[i]);
//      }

//      System.out.println("");

     if (AID == Const.CRLAID) {

       cs.sendCSToCAB(a);
     }
     else

      cs.sendCSToApp(m);

   }

  public void handleRASK(Message a){

   
   //  RaskMessage m = (RaskMessage ) a;
//     int lUID = m.getLocalUID();
//     int SID = m.getSID();
//     int AT = m.getAT();
  
//     System.out.println("DEMON: RASK message received");
//     System.out.println("DEMON: AT " + AT + " SID " + SID + " UID " + UID);
    

    cs.sendCSToCAB(a);
    
    
	
  }

  public void handleSUPD(Message a){

     SupdMessage m = (SupdMessage) a;
     int param = m.getPARAM();
     int SID = m.getSID();
     int UID = m.getUID();
     int AT = m.getAT(); 
     String name = m.getName();


     System.out.println("DEMON: SUPD message received");
     System.out.println("DEMON: SID" + SID + " AT " + AT + " UID " + UID + " param " + param + " name " + name);
    
     cs.sendCSToCAB(a);
   
  }

  public void handleMASK(Message a){

   //  MaskMessage m = (MaskMessage) a;
//     int SID = m.getSID();
//     int UID = m.getUID();

//     System.out.println("DEMON: MASK message received");
//     System.out.println("DEMON: SID " + SID + " UID " + UID);

    cs.sendCSToCAB(a);
    
  }

  public void handleLOGACC(Message a){

     LogaccMessage m = (LogaccMessage) a;
     UID = m.getUID();
 //    String priv = m.getPrivileges();
 
    
 //    System.out.println("DEMON: LOGACC message received");

 //    if (UIDpar != 0) {
 //      System.out.println("DEMON: user accepted witch number " + UIDpar + " and privileges " + priv);
 //      UID = UIDpar;
 //    }
 //    else
 //      System.out.println("DEMON: access refused");
    
    cs.sendCSToCAB(a);
  }

  public void handleJASK(Message a){


   //  JaskMessage m = (JaskMessage ) a;
//     int lUID = m.getUID();
//     int SID = m.getSID();
//     int AT = m.getAT();
   
//     System.out.println("DEMON: JASK message received");
//     System.out.println("DEMON: AT " + AT+ " SID " + SID + " UID " + lUID);


    cs.sendCSToCAB(a);
    
    	
  }


  public void handleJANS(Message a) {

 //    JansMessage jm = (JansMessage) a;
//     int AT = jm.getAT();
//     int SID = jm.getSID();
//     int lUID = jm.getUID();
//     int ans = jm.getAnswer();
    
    
//     System.out.println("DEMON: JANS message received");
//     System.out.println("DEMON: AT " + AT+ " SID " + SID + " UID " + lUID + " ans " + ans);
    cs.sendCSToCAB(a);
  }

  public void handleRANS(Message a) { 

   //  RansMessage rm = (RansMessage) a;
//     int AT = rm.getAT();
//     int SID = rm.getSID();
//     int lUID = rm.getRemoteUID();
//     int rUID = rm.getLocalUID();
//     int ans = rm.getAnswer();



//     System.out.println("DEMON: RASK message received");
//     System.out.println("DEMON: AT " + AT+ " SID " + SID + " remote UID " + rUID + " local UID " + lUID + " ans " + ans);
  
    cs.sendCSToCAB(a);
  }

  
  public void handleMANS(Message a) {

 //    MansMessage mm = (MansMessage) a;
//     int SID = mm.getSID();
//     int lUID = mm.getUID();
//     int ans = mm.getAnswer();
    
    
//     System.out.println("DEMON: MASK message received");
//     System.out.println("DEMON: SID " + SID + " UID " + lUID + " ans " + ans);    

    cs.sendCSToCAB(a);
  }
  
  
  public void handlePING(Message a) {
  
  	 System.out.println("DemonProtocol: ping received");	
		out.putMessage(a);
  
  }

  public void logout() {

    LogoutMessage a = new LogoutMessage(UID);
    out.putMessage(a);

  }

  public void started(int AID, int SID) {

    StartedMessage s = new StartedMessage(AID, SID);
    out.putMessage(s);

  }

}











